-# haml-lint:disable ViewLength
= vite_javascript_tag 'vue-tag-selector'

- url = resource.id ? admin_resource_path(resource) : admin_resources_path
= form_for resource, url: url do |f|
  = render 'layouts/form_errors',
           entity: resource,
           message: t('.errors', count: resource.errors.count)

  ._show-page
    %section
      %fieldset.-mbd
        %legend= t('.classification')

        .rui-field
          = f.label :name
          = f.text_field :name, required: true
        .rui-field
          = f.label :latin_name
          = f.text_field :latin_name, required: true
        .rui-field
          = f.label :genus_id, t('activerecord.attributes.resource.genus')
          = f.collection_select :genus_id, Genus.order(:name), :id, :name, { include_blank: true }, required: true
        .rui-field
          = f.label :parent_id, t('activerecord.attributes.resource.parent')
          = f.collection_select :parent_id, Resource.parentable.order(:name), :id, :name, prompt: true
        .rui-field
          = f.label :resource_interactions_group
          = f.collection_select :resource_interactions_group_id,
                                ResourceInteractionsGroup.order(:name),
                                :id,
                                :name,
                                prompt: true
          .rui-field__help= t('.resource_interactions_group_help')
        .rui-field
          = f.label :common_names
          = f.text_field :common_names, value: resource.common_names.join(', ')
          .rui-field__help= t('generic.comma_separated_values')

      %fieldset.-mbd
        %legend= t('.metadata')

        .rui-field
          = f.label :crop_rotation_group
          = f.select :crop_rotation_group, enum_options_for_select(Resource, :crop_rotation_group), include_blank: true
        .rui-field
          = f.label :tag_list
          = tag_selector f, :tag_list, :resource_tag_list, resource.tag_list
        .rui-field
          = f.label :diameter
          = f.number_field :diameter, step: 0.01, min: 0
        - if resource.id
          .rui-field
            = f.label :color do
              = t('activerecord.attributes.resource.color')
              ._gp-color-preview#color-preview
            = f.text_field :color, required: true
            .rui-field__help= t('.color_help')

      %fieldset.-mbd
        %legend= t('.documentation')
        .rui-field
          = f.label :sources
          = f.text_area :sources, value: resource.sources.join("\n")
          .rui-field__help= t('.sources_help')

    %section._show-page__content
      .rui-field
        = f.label :description
        = f.text_area :description, class: '-markdown -large -mbd'

      - Resource::BITFIELD_MONTHS_ATTRIBUTES.each_pair do |field, prefix|
        %fieldset.-mbd
          %legend= t("activerecord.attributes.resource.#{field}")
          .gp-month-flags-input
            - fields = GardenParty::BitfieldModelHelper.bitfield_months(prefix)
            - fields.each_pair do |key, attribute|
              = f.label attribute do
                = f.check_box attribute
                = t('date.abbr_month_names')[fields.keys.find_index(key) + 1]

  = render 'layouts/form_actions'

- if resource.id
  :javascript
    const target = document.getElementById('color-preview')
    const input  = document.getElementById('resource_color')

    function updateColorPreview() {
      let valid = true
      input.value.split(',').map(function(c) {return c.trim()}).forEach(function(e) {
        const value = parseInt(e, 10)
        if(!/^\d{1,3}$/.test(e) || value > 255 || value < 0) valid = false
      })
      if(valid) {
        target.style.backgroundColor= 'rgb('+input.value+')'
        input.setCustomValidity('');
      } else {
        input.setCustomValidity('#{escape_javascript(t('activerecord.errors.bad_color_segment'))}');
      }
    }

    document.addEventListener('DOMContentLoaded', function () {
      document.getElementById('resource_color').addEventListener('keyup', updateColorPreview)
      updateColorPreview()
    })
-# haml-lint:enable ViewLength
